update to 2.3 based on netbsd stuff